<template>
  <cdx-dialog
    :open="open"
    title="External Tools"
    close-button-label="Close"
    :primary-action="primaryAction"
    :default-action="defaultAction"
    class="text-black"
    @update:open="emit('update:open', false)"
    @primary="nearbySubmit"
    @default="emit('update:open', false)"
  >
    <div class="mb-5">
      <p class="mb-1 font-medium">ExternalTools URL (PetScan, Wikidata query service):</p>
      <CdxTextInput v-model="url" class="mb-3" placeholder="Enter URL" />
      <p class="text-red-500 mb-2">{{ error }}</p>
    </div>

    <div class="mb-6">
      <p class="font-medium mb-1">Number of words to get?</p>
      <CdxTextInput
        v-model="numberOfWords"
        input-type="number"
        class="mb-3"
        placeholder="Number of words"
      />
    </div>

    <cdx-toggle-switch v-model="removeRecordedWords"
      >Exclude words you have already recorded</cdx-toggle-switch
    >
  </cdx-dialog>
</template>

<script setup>
import {
  CdxButton,
  CdxField,
  CdxTextInput,
  CdxIcon,
  CdxDialog,
  CdxToggleSwitch,
} from '@wikimedia/codex'
import { cdxIconTrash, cdxIconLogoWikipedia, cdxIconMapPin } from '@wikimedia/codex-icons'
import { useRecordWizardStore } from '@/stores/recordwizard'
import makeApiCall from '@/utils/makeApiCall.js'
import { defineProps, defineEmits, ref } from 'vue'
import getLocutorRecordings from '@/utils/getLocutorRecordings.js'

const numberOfWords = ref(100)
const url = ref(null)
const error = ref(null)

const props = defineProps({
  open: Boolean,
})

const emit = defineEmits(['update:open', 'canGoToNextStep'])

const store = useRecordWizardStore()

const primaryAction = {
  label: 'Save',
  actionType: 'progressive',
}

const defaultAction = {
  label: 'Cancel',
}

const removeRecordedWords = ref(false)

const PETSCAN_URL = 'petscan.wmflabs.org/'
const WDQS_URL = 'query.wikidata.org/'

async function nearbySubmit() {
  emit('update:open', false)
  let urlType = ''
  let finalUrl = url.value
  if (
    finalUrl.lastIndexOf('http://' + PETSCAN_URL, 0) === 0 ||
    finalUrl.lastIndexOf('https://' + PETSCAN_URL, 0) === 0
  ) {
    urlType = 'petscan'
    finalUrl =
      finalUrl +
      `&output_compatability=quick-intersection&format=json&doit=${!removeRecordedWords.value && `&output_limit=${numberOfWords.value}`}`
  } else if (finalUrl.lastIndexOf('https://' + WDQS_URL, 0) === 0) {
    urlType = 'wikidata'
    finalUrl = finalUrl.replace(
      'https://query.wikidata.org/#',
      'https://query.wikidata.org/sparql?query=',
    )
    if (!/limit/i.test(finalUrl)) {
      finalUrl += `%0ALIMIT ${removeRecordedWords.value ? '1000000' : numberOfWords.value}`
    }
    finalUrl += '&format=json'
  } else {
    error.value = 'This is not an allowed URL... It should link to PetScan or Wikidata Query.'
    return
  }
  const response = await makeApiCall(
    'get',
    finalUrl,
    (e) => (error.value = e),
    false,
    {},
    {
      'Content-Type': 'application/x-www-form-urlencoded',
    },
    {},
  )

  let titles =
    urlType === 'petscan'
      ? response.pages.map((item) => item.page_title)
      : response.results.bindings.map((item) => item.label.value)

  if (removeRecordedWords.value) {
    const recordedWords = await getLocutorRecordings()
    titles = titles.filter((title) => !recordedWords.includes(title))
  }
  store.addWordsArray(titles.slice(0, numberOfWords.value))
  emit('canGoToNextStep')
}
</script>
